    GetPasswordSum Proc
        mov bx,offset Password
        xor al,al
      @@AddByte:
        add al,[bx]
        inc bx
        cmp byte ptr [bx],0
        jnz @@AddByte
        mov PasswordSum,al
        ret
    GetPasswordSum EndP
    EncryptBuffer Proc
        mov di,offset Buffer
      @@ProcessPassword:
        mov si,offset Password
      @@PasswordLoop:
        lodsb
        or al,al
        jz @@ProcessPassword
        xor al,[di]
        stosb
        cmp di,offset Buffer+BufferSize
        jne @@PasswordLoop
        mov bx,offset Buffer
        mov cl,'V'
        mov al,PasswordSum
      @@ShiftBytes:
        add [bx],cl
        ror byte ptr [bx],cl
        sub [bx],al
        inc cl
        inc bx
        cmp bx,offset Buffer+BufferSize
        jne @@ShiftBytes
        ret
    EncryptBuffer EndP
    DecryptBuffer Proc
        mov bx,offset Buffer
        mov cl,'V'
        mov al,PasswordSum
      @@ShiftBytes:
        add [bx],al
        rol byte ptr [bx],cl
        sub [bx],cl
        inc cl
        inc bx
        cmp bx,offset Buffer+BufferSize
        jne @@ShiftBytes
        mov di,offset Buffer
      @@ProcessPassword:
        mov si,offset Password
      @@PasswordLoop:
        lodsb
        or al,al
        jz @@ProcessPassword
        xor al,[di]
        stosb
        cmp di,offset Buffer+BufferSize
        jne @@PasswordLoop
        ret
    DecryptBuffer EndP
    EncryptFile Proc
        call OpenFile
        mov bx,offset EncryptingStr
        call Write
        mov bx,offset SearchStruc.FileName
        call WriteLn
      @@ProcessBuffer:
        call ReadBuffer
        call EncryptBuffer
        call WriteBuffer
        jnc @@ProcessBuffer
        call CloseFile
        ret
      EncryptingStr DB ' ',0
    EncryptFile EndP
    DecryptFile Proc
        call OpenFile
        mov bx,offset DecryptingStr
        call Write
        mov bx,offset SearchStruc.FileName
        call WriteLn
      @@ProcessBuffer:
        call ReadBuffer
        call DecryptBuffer
        call WriteBuffer
        jnc @@ProcessBuffer
        call CloseFile
        ret
      DecryptingStr DB '஢뢠 ',0
    DecryptFile EndP
