Model Tiny
Locals
  Space Equ 20h
  CR Equ 0dh
  LF Equ 0ah
  BkSp Equ 8
  MaxPasswordLength Equ 20
  BufferSize Equ 512

  DSearchStruc Struc
    Reserved DB 21 Dup(0)
    FileAttr DB 0
    FileTime DD 0
    FileSize DD 0
    FileName DB 13 Dup(0)
  DSearchStruc EndS
DataSeg
  DoneStr DB '⮢.',0
  InvalidFileMaskStr DB '୮  䠩.',0
  HelpStr DB 13,10,'--== DATACODE 3.1 ==--        17-Dec-1995       ⬨',13,10,13,10
          DB 'ᯮ짮 : DC [filespec]',13,10
          DB 'filespec -  䠩, 饣 ࠡ⪥ (  蠡  )',0
  CRLF DB CR,LF,0
  Password DB MaxPasswordLength Dup(0)
  SearchStruc DSearchStruc ?
  Handle DW 0
  Buffer DB BufferSize Dup(0)
  FileMask DB 64 Dup(0)
  NumRead DW 0
  PasswordSum DB 0
  EncryptFlag DB 0
CodeSeg
  StartupCode
	call Main
    	mov ah,4ch
    	int 21h
    Include DCOUTP.INC
    Include DCINP.INC
    Include DCFILES.INC
    Include DCENCDEC.INC
    Main Proc
        mov dx,offset SearchStruc
        mov ah,1ah
        int 21h
        call AnalyzeCommandLine
        jc @@Help
        call FindFirst
        jc @@InvalidFileMask
        call ClrScr
        call GetPassword
        call GetEncryptFlag
        call GetPasswordSum
      @@ProcessFile:
        cmp EncryptFlag,1
        je @@Encrypt
        call DecryptFile
        jmp @@FileProcessed
      @@Encrypt:
        call EncryptFile
      @@FileProcessed:
        call FindNext
        jnc @@ProcessFile
        mov bx,offset DoneStr
        call WriteLn
        jmp @@Exit
      @@Help:
        mov bx,offset HelpStr
        call WriteLn
        jmp @@Exit
      @@InvalidFileMask:
        mov bx,offset InvalidFileMaskStr
        call WriteLn
      @@Exit:
        ret
    Main EndP
End
